<?php

namespace STM\Competition\Playoff\Team;

use \GetterOfTestingInstances;
use STM\Competition\Playoff\Playoff;

/**
 * Test class for PlayoffTeamValidator.
 * Generated by PHPUnit on 2012-02-05 at 19:28:21.
 * @group competition_playoff
 */
class PlayoffTeamValidatorTest extends \PHPUnit_Framework_TestCase {

    /** @var Playoff */
    private $playoff;
    /** @var array */
    private $valid_seeded;

    protected function setUp() {
        PlayoffTeamValidator::init();
        $this->playoff = GetterOfTestingInstances::getPlayoff();
        if (!$this->playoff) {
            return;
        }
        PlayoffTeamValidator::setPlayoff($this->playoff);
        $this->valid_seeded = array();
        foreach ($this->playoff->getTeamsWithSeeded() as $playoff_team) {
            $this->valid_seeded[$playoff_team->getIdTeam()] = $playoff_team->getSeeded();
        }
    }

    public function test_check_not_setPlayoff() {
        PlayoffTeamValidator::resetPlayoff();
        $this->assert_bad_arguments(array());
        $this->assert_bad_arguments(null);
    }

    public function test_no_change() {
        $this->assert_bad_arguments($this->valid_seeded);
    }

    public function test_invalid_array_count() {
        if (!$this->playoff) {
            return;
        }
        array_shift($this->valid_seeded);
        $this->assert_bad_arguments($this->valid_seeded);
    }

    public function test_bad_range_of_number() {
        if (!$this->playoff) {
            return;
        }
        $first = array_shift($this->valid_seeded);
        $first = 0;
        array_unshift($this->valid_seeded, $first);
        $this->assert_bad_arguments($this->valid_seeded);
        
        $first = array_shift($this->valid_seeded);
        $first = PLAYOFF_MAX_TEAMS * 2;
        array_unshift($this->valid_seeded, $first);
        $this->assert_bad_arguments($this->valid_seeded);
    }

    public function test_playoff_with_generated_first_round() {
        foreach (GetterOfTestingInstances::find_playoffs() as $playoff) {
            if ($playoff->getPlayedRounds() >= 1) {
                PlayoffTeamValidator::setPlayoff($playoff);
                $first = array_shift($this->valid_seeded);
                $first = 1;
                array_unshift($this->valid_seeded, $first);
                $this->assert_bad_arguments($this->valid_seeded);
            }
        }
    }

    private function assert_bad_arguments($seeded) {
        PlayoffTeamValidator::init();
        parent::assertFalse(PlayoffTeamValidator::checkPlayoffSeeded($seeded));
        PlayoffTeamValidator::init();
    }

}

?>
